\ Abstract terminal

\ Copyright (C) 2000 Alex Malyshev (alexript@mail.ru)

\ This is free software; you can redistribute it and/or
\ modify it under the terms of the GNU General Public License
\ as published by the Free Software Foundation; either version 2
\ of the License, or (at your option) any later version.

\ This program is distributed in the hope that it will be useful,
\ but WITHOUT ANY WARRANTY; without even the implied warranty of
\ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
\ GNU General Public License for more details.

\ You should have received a copy of the GNU General Public License
\ along with this program; if not, write to the Free Software
\ Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

uses StartUp

: TerminalVoidFunction ;

DEFER Black
DEFER Red
DEFER Green
DEFER Yellow
DEFER Blue
DEFER Brown
DEFER Cyan
DEFER White

DEFER Normal
DEFER Bold
DEFER Underline
DEFER Italic
DEFER Blink
DEFER FastBlink
DEFER Invers
DEFER Shadow

DEFER CurPos	( x y -- )
DEFER SaveCurPos ( -- )
DEFER RestoreCurPos ( -- )
DEFER CursorUp ( n -- )
DEFER CursorDown ( n -- )
DEFER CursorForward ( n -- )
DEFER CursorBack ( n -- )
DEFER .CR ( n -- )
DEFER ReverseCR ( n -- )
DEFER EraseLine ( -- )
DEFER DeleteTC ( -- )
DEFER DeleteLine ( -- )
DEFER EraseCE ( -- )
DEFER EraseBC ( -- )
DEFER EraseDisplay ( -- )
DEFER InsSpaces ( n -- )
DEFER DelChars ( n -- )
DEFER InsLines ( n -- )
DEFER DelLines ( n -- )
DEFER InsMode ( f -- )
DEFER SetBG ( color -- )
DEFER SetFG ( color -- )
DEFER SetFGBG ( fgcolor bgcolor -- )
DEFER SetAttr ( attr -- )
DEFER UnSetAttr ( attr -- )
DEFER GetDefAttr ( -- fgcolor bgcolor attr )
DEFER SetDefAttr ( fgcolor bgcolor attr -- )
DEFER .DefAttr ( -- )

DEFER .AttrString ( s-addr s-u fgcolor bgcolor attr -- )
DEFER TTYClose

: TerminalInit
['] NIL IS Black
['] NIL IS Red
['] NIL IS Green
['] NIL IS Yellow
['] NIL IS Blue
['] NIL IS Brown
['] NIL IS Cyan
['] NIL IS White

['] NIL IS Normal
['] NIL IS Bold
['] NIL IS Underline
['] NIL IS Italic
['] NIL IS Blink
['] NIL IS FastBlink
['] NIL IS Invers
['] NIL IS Shadow

['] TerminalVoidFunction IS CurPos
['] TerminalVoidFunction IS SaveCurPos
['] TerminalVoidFunction IS RestoreCurPos
['] TerminalVoidFunction IS CursorUp
['] TerminalVoidFunction IS CursorDown
['] TerminalVoidFunction IS CursorForward
['] TerminalVoidFunction IS CursorBack
['] TerminalVoidFunction IS .CR
['] TerminalVoidFunction IS ReverseCR
['] TerminalVoidFunction IS EraseLine
['] TerminalVoidFunction IS DeleteTC
['] TerminalVoidFunction IS DeleteLine
['] TerminalVoidFunction IS EraseCE
['] TerminalVoidFunction IS EraseBC
['] TerminalVoidFunction IS EraseDisplay
['] TerminalVoidFunction IS InsSpaces
['] TerminalVoidFunction IS DelChars
['] TerminalVoidFunction IS InsLines
['] TerminalVoidFunction IS DelLines
['] TerminalVoidFunction IS InsMode
['] TerminalVoidFunction IS SetBG
['] TerminalVoidFunction IS SetFG
['] TerminalVoidFunction IS SetFGBG
['] TerminalVoidFunction IS SetAttr
['] TerminalVoidFunction IS UnSetAttr
['] TerminalVoidFunction IS GetDefAttr
['] TerminalVoidFunction IS SetDefAttr
['] TerminalVoidFunction IS .DefAttr
['] TerminalVoidFunction IS .AttrString
['] TerminalVoidFunction IS TTYClose
;

TerminalInit
